
<!DOCTYPE html>
<html>
  <head>
    <title>Marking with react</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css" integrity="sha384-50oBUHEmvpQ+1lW4y57PTFmhCaXp0ML5d60M1M7uH2+nqUivzIebhndOJK28anvf" crossorigin="anonymous">
    <link href="https://fonts.googleapis.com/css?family=Boogaloo&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="style.css">
<script src="https://cdn.jsdelivr.net/npm/marked/marked.min.js"></script>
    <script crossorigin src="https://unpkg.com/react@16/umd/react.production.min.js"></script>
<script crossorigin src="https://unpkg.com/react-dom@16/umd/react-dom.production.min.js"></script>
  </head>
  <body>
      <a href="https://linkedin.com/in/fsbalbuena/">FSBalbuena</a>  
    <main id="main"></main>
    <script src="https://unpkg.com/babel-standalone@6/babel.min.js"></script>
    <script type="text/babel">
    
  
//Probado, anda bien- La clase se la ponemos con el id a los dos
const Editor=({text,handleChange})=>(<textarea id="editor" onChange={handleChange} value={text}></textarea>)
const Preview=({text})=>(<pre>{text}</pre>)


//si tiene un onclick lo armamos con un span en el container
const Icon=({type})=>(<i className={type}></i>)

//no tiene que manejar handlers por que los children lo arma el container
const IconGroup=({children})=>(<div className="iconGroup">{children}</div>)

//le meto una clase para referenciarlo nada mas
const LogoText=({text})=>(<p className="logo">{text}</p>)
//--------------------------------------------------------
//NAVBARS--------------------------------------------------
class MainNavbar extends React.Component{
    constructor(props){
      super(props)
      this.state={
        iconList:[
        {type:"fas fa-columns",isActive:true,name:"all"},
        {type:"fas fa-edit",isActive:false,name:"editor"},
        {type:"fas fa-eye",isActive:false,name:"preview"}
    ],
      text:"React-MD"
      }
      this.handleClick=this.handleClick.bind(this)
    }
    handleClick(name){
      let array=this.state.iconList.map(i=>{
        i.isActive=i.name==name
        return i
      })
      this.props.handleClick(name)
      this.setState({iconList:array})
    }
    
    render(){
      const {text,iconList}=this.state
      return (
        <div className="navbar mainNavbar">
            <LogoText text={text}/>
            <IconGroup >
              {iconList.map(i=><span key={i.name} className={i.isActive?"is active":"is"} onClick={()=>this.handleClick(i.name)}><Icon type={i.type}/></span>)}
            </IconGroup>
        </div>
        )
    }
    
}

const DisplayNavbar=({text,type})=> (
        <div className="navbar displayNavbar">
            <LogoText text={text}/>
            <Icon type={type}/>
        </div>
        )
//----------------------------------------------------------
//DISPLAYERS------------------------------------
const EditorComponent =({text,handleChange})=>(
    <div className="textDisplay">
 <DisplayNavbar type="fas fa-pencil-alt" text="Editor" />
 <Editor text={text} handleChange={handleChange}/>
 </div>)

class PreviewComponent extends React.Component{
  componentDidMount(){
    let text=marked(this.props.text)
    console.log()
    document.getElementById("preview").innerHTML=text
  }
  componentDidUpdate(){
    let text=marked(this.props.text)
    document.getElementById("preview").innerHTML=text
  }
  render(){
    return (
    <div className="textDisplay">
  <DisplayNavbar type="fas fa-file" text="Preview" />
        <div id="preview"></div>
 </div>)
  }
}


//----------------------------------------------------
//---------------------------------------------------
class Main extends React.Component{
    constructor(props){
      super(props)
      this.state={
      text:"# i am h1\n## i am h2\n It's very easy to make some words **bold** and other words *italic* with Markdown. You can even [link to Google!](http://google.com) and `i am inline code`\n but also you have \n\n```ruby\nrequire 'redcarpet'\nmarkdown = Redcarpet.new('Hello World!'')\nputs markdown.to_html\n```\n* Item 1\n* Item 2\n   > bar We're living the future so\n ![GitHub Logo](https://github.githubassets.com/images/modules/logos_page/GitHub-Mark.png)",
        flag:"all"
        }
      
     this.handleChange=this.handleChange.bind(this)
     this.handleClick=this.handleClick.bind(this)
        
    }
  componentDidMount(){
    if(document.body.offsetWidth<=900){
      this.setState({flag:"editor"})
    }
  }
  handleChange(e){
    this.setState({text:e.target.value})
  }
  handleClick(name){
    this.setState({flag:name})
  }
  render(){
    const {text,flag}=this.state
    return (<div>
        <MainNavbar handleClick={this.handleClick} />
        <div className={flag!="all"?"onlyOne":"displays"}>
          {flag=="all" | flag=="editor"?<EditorComponent text={text} handleChange={this.handleChange}/>:null}
          {flag=="all" | flag=="preview"?<PreviewComponent text={text}/>:null}
        </div>
        </div>)
  }
}

ReactDOM.render(<Main/>,document.getElementById("main"))

    </script>
  </body>
</html>